<template>
    <div ref="addNotebookForm" class="add-notebook-form">
        <div ref="overlay" @click="handleClose" class="overlay"></div>
        <div ref="formWrapper" class="form-wrapper" style="transform: translateY(100vh)">
            <h1>Add Notebook</h1>
            <form class="form">
                <!-- Name Input -->
                <input
                    v-model="$v.form.name.$model"
                    name="notebook-name"
                    type="text"
                    placeholder="Notebook Name"
                />
                <!-- Error Messages -->
                <span class="error" v-if="!$v.form.name.minLength && $v.form.name.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Minimum Length is
                        <strong>2</strong> Characters
                    </span>
                </span>
                <span class="error" v-if="!$v.form.name.maxLength && $v.form.name.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Maximium Length is
                        <strong>30</strong> Characters
                    </span>
                </span>
                <span class="error" v-if="!$v.form.name.required && $v.form.name.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Notebook Title Is
                        <strong>Required</strong>
                    </span>
                </span>
                <!-- Description Input -->
                <input
                    v-model="$v.form.description.$model"
                    name="notebook-description"
                    type="text"
                    placeholder="Description (Optional)"
                />
                <!-- Error Messages -->
                <span
                    class="error"
                    v-if="!$v.form.description.minLength && $v.form.description.$dirty"
                >
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Minimum Length is
                        <strong>2</strong> Characters
                    </span>
                </span>
                <span
                    class="error"
                    v-if="!$v.form.description.maxLength && $v.form.description.$dirty"
                >
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Maximium Length is
                        <strong>255</strong> Characters
                    </span>
                </span>
                <div class="actions">
                    <button @click.prevent="handleSubmit" class="save">Save</button>
                    <button @click.prevent="handleClose" class="cancel">Cancel</button>
                </div>
            </form>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Watch, Prop } from 'vue-property-decorator'
import { validationMixin } from 'vuelidate'
import { required, maxLength, minLength } from 'vuelidate/lib/validators'
import anime, { AnimeParams } from 'animejs'
import { offlineDB } from '@/offline/db'
import {
    AddNotebookFormRefs,
    AddNotebookForm,
} from '@/app/Editor/types/addNotebookForm'
import { INotebook } from '@/store/types/notebooks'

const validations = {
    form: {
        name: {
            required,
            minLength: minLength(2),
            maxLength: maxLength(30),
        },
        description: {
            minLength: minLength(2),
            maxLength: maxLength(255),
        },
    },
}

const customVNode = Vue.extend({
    validations,
    mixins: [validationMixin],
})

@Component
export default class AddNotebookFormNode extends customVNode {
    // Lifecycles
    mounted() {
        const { overlay, addNotebookForm, formWrapper } = this
            .$refs as AddNotebookFormRefs
        this.overlay = overlay
        this.addNotebookForm = addNotebookForm
        this.formWrapper = formWrapper
    }

    // Props

    @Prop({ default: false }) open: boolean = false

    // Data

    addNotebookForm: Element | undefined
    overlay: Element | undefined
    formWrapper: Element | undefined
    animationSettings: AnimeParams = {
        duration: 250,
        easing: 'cubicBezier(0.4,0.0,0.2,1)',
    }
    form: AddNotebookForm = {
        name: '',
        description: '',
    }
    validations = {
        form: {
            name: {
                required,
                minLength: minLength(2),
                maxLength: maxLength(30),
            },
            description: {
                minLength: minLength(2),
                maxLength: maxLength(255),
            },
        },
    }

    // Watchers
    @Watch('open', { immediate: true })
    watchOpen(newOpenState: boolean) {
        if (newOpenState) {
            // if true
            if (this.formWrapper && this.overlay) {
                if (this.addNotebookForm)
                    this.addNotebookForm.classList.add('open')
                this.initStateForm(this.formWrapper)
                this.initStateOverlay(this.overlay)
            }
        } else {
            // if false
            if (this.formWrapper && this.overlay) {
                this.leaveActiveForm(this.formWrapper)
                this.leaveActiveOverlay(this.overlay)
            }
        }
    }

    // Methods

    async handleSubmit() {
        try {
            if (this.$v.$invalid) {
                // Handle Error
            } else {
                const notebook: INotebook = {
                    name: this.form.name,
                    createdOn: new Date(),
                    editedOn: new Date(),
                }

                if (this.form.description && this.form.description.length > 1)
                    notebook.description = this.form.description
                await offlineDB.saveNotebook(notebook)
                offlineDB.saveCurrentNotebook(notebook)
                this.$emit('close', false)
            }
        } catch (error) {
            throw new Error(error)
        }
    }

    handleClose() {
        this.$emit('close', false)
    }

    handleCreateNotebook() {}

    // SPECIAL

    // Animation

    // 1. Actions

    initStateForm(el: Element) {
        this.enterActiveForm(el)
    }

    enterActiveForm(el: Element) {
        anime({
            targets: el,
            translateY: 0,
            ...this.animationSettings,
        })
    }

    leaveActiveForm(el: Element) {
        anime({
            targets: el,
            translateY: '100vh',
            ...this.animationSettings,
        })
    }

    // 2. Overlay

    initStateOverlay(el: Element) {
        this.enterActiveOverlay(el)
    }

    enterActiveOverlay(el: Element) {
        anime({
            targets: el,
            opacity: 0.35,
            ...this.animationSettings,
        })
    }

    leaveActiveOverlay(el: Element) {
        anime({
            targets: el,
            opacity: 0,
            ...this.animationSettings,
            complete: () => {
                if (this.addNotebookForm)
                    this.addNotebookForm.classList.remove('open')
            },
        })
    }
}
</script>